﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.C1Preview;
using C1.C1Report;
using C1.Win.C1Preview;
using C1.Win;

namespace C1PrintDocument_CustomizingPageFooter
{
    public partial class Form1 : Form
    {
        C1PrintDocument C1PrintDocument1 = new C1PrintDocument();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            C1PrintDocument1.AllowNonReflowableDocs = false;
            RenderTable renderTable1 = new RenderTable();
            int row = 0;
            int col = 0;
            while ((row < 80))
            {
                col = 0;
                while ((col < 3))
                {
                renderTable1.Cells[row, col].Style.Borders.All = LineDef.Default;
                string s = String.Format("Text in cell({0},{1})", row, col);
                RenderText rtxt = new RenderText(s);
                rtxt.Style.TextAlignHorz = AlignHorzEnum.Center;
                rtxt.Style.Borders.All = new LineDef(Color.Red);
                rtxt.Width = "2cm";
                RenderArea ra = new RenderArea();
                ra.Stacking = StackingRulesEnum.BlockLeftToRight;
                ra.Style.FlowAlignChildren = FlowAlignEnum.Center;
                ra.Children.Add(rtxt);
                renderTable1.Cells[row, col].RenderObject = ra;
                col += 1;
                }
                row += 1;
            }
            col = 0;
            while ((col < 3))
            {
                renderTable1.Cols[col].Width = "1in";
                col += 1;
            }

            row = 0;
            col = 0;
            C1PrintDocument1.Body.Children.Add(renderTable1);

            // Setting the PageFooter for all the pages except the last page
            PageLayout pagelayout = new PageLayout();
            RenderText pagefooter = new RenderText();
            pagefooter.Text = " Continued to Next Page...";
            pagefooter.Style.Borders.All = LineDef.Default;
            pagefooter.Style.FontBold = true;
            pagefooter.Style.TextColor = Color.Maroon;
            pagelayout.PageFooter = pagefooter;
            C1PrintDocument1.PageLayouts.PrintFooterOnLastPage = false;
            C1PrintDocument1.PageLayout.PageFooter = pagelayout.PageFooter;
            C1PrintDocument1.Generate();

            // In case the number of pages is 1, hide PageFooter on the first page itself and generate the document again so as to reflect the changes.
            if (C1PrintDocument1.Pages.Count == 1)
            {
                C1PrintDocument1.PageLayouts.PrintFooterOnFirstPage = false;
            }
            // Code to apply border around the C1PrintDocument
            RenderArea overlay = new RenderArea();
            overlay.Width = "100%";
            overlay.Height = "100%";
            overlay.Style.Borders.All = LineDef.Default;
            C1PrintDocument1.PageLayout.Overlay = overlay; 
         
            C1PrintDocument1.Generate();
            c1PrintPreviewControl1.Document = C1PrintDocument1;

        }
    }
}
